searchData={"items":[{"type":"module","title":"DepsNix","doc":"","ref":"DepsNix.html"},{"type":"type","title":"DepsNix.converger/0","doc":"","ref":"DepsNix.html#t:converger/0"},{"type":"function","title":"DepsNix.github_prefetcher/3","doc":"","ref":"DepsNix.html#github_prefetcher/3"},{"type":"function","title":"DepsNix.parse_args/1","doc":"","ref":"DepsNix.html#parse_args/1"},{"type":"function","title":"DepsNix.run/2","doc":"","ref":"DepsNix.html#run/2"},{"type":"module","title":"DepsNix.Derivation","doc":"","ref":"DepsNix.Derivation.html"},{"type":"function","title":"DepsNix.Derivation.from/2","doc":"","ref":"DepsNix.Derivation.html#from/2"},{"type":"function","title":"DepsNix.Derivation.new/2","doc":"","ref":"DepsNix.Derivation.html#new/2"},{"type":"type","title":"DepsNix.Derivation.t/0","doc":"","ref":"DepsNix.Derivation.html#t:t/0"},{"type":"module","title":"DepsNix.FetchFromGitHub","doc":"","ref":"DepsNix.FetchFromGitHub.html"},{"type":"type","title":"DepsNix.FetchFromGitHub.t/0","doc":"","ref":"DepsNix.FetchFromGitHub.html#t:t/0"},{"type":"module","title":"DepsNix.FetchGit","doc":"","ref":"DepsNix.FetchGit.html"},{"type":"type","title":"DepsNix.FetchGit.t/0","doc":"","ref":"DepsNix.FetchGit.html#t:t/0"},{"type":"module","title":"DepsNix.FetchHex","doc":"","ref":"DepsNix.FetchHex.html"},{"type":"type","title":"DepsNix.FetchHex.t/0","doc":"","ref":"DepsNix.FetchHex.html#t:t/0"},{"type":"module","title":"DepsNix.Options","doc":"","ref":"DepsNix.Options.html"},{"type":"type","title":"DepsNix.Options.t/0","doc":"","ref":"DepsNix.Options.html#t:t/0"},{"type":"module","title":"DepsNix.Packages","doc":"","ref":"DepsNix.Packages.html"},{"type":"function","title":"DepsNix.Packages.dependency_names/2","doc":"","ref":"DepsNix.Packages.html#dependency_names/2"},{"type":"function","title":"DepsNix.Packages.filter/2","doc":"","ref":"DepsNix.Packages.html#filter/2"},{"type":"function","title":"DepsNix.Packages.reject_paths/1","doc":"","ref":"DepsNix.Packages.html#reject_paths/1"},{"type":"module","title":"DepsNix.Path","doc":"","ref":"DepsNix.Path.html"},{"type":"type","title":"DepsNix.Path.t/0","doc":"","ref":"DepsNix.Path.html#t:t/0"},{"type":"module","title":"DepsNix.Util","doc":"","ref":"DepsNix.Util.html"},{"type":"function","title":"DepsNix.Util.indent/1","doc":"","ref":"DepsNix.Util.html#indent/1"},{"type":"function","title":"DepsNix.Util.indent/2","doc":"","ref":"DepsNix.Util.html#indent/2"},{"type":"task","title":"mix deps.nix","doc":"Creates Nix derivations for Mix dependencies.\n\nWhen run without arguments, generates `deps.nix` in the current directory, but\nonly for `:prod` dependencies.\n\nThe resulting file contains a Nix function that can be called with an empty\nattribute set:\n\n```\npkgs.callPackages ./deps.nix { }\n```\n\nThat attribute set can optionally include overrides, which look like Nix\noverlays:\n\n```\npkgs.callPackages ./deps.nix {\n  overrides = (\n    final: prev: {\n      some_mix_dep = prev.some_mix_dep.override {\n        mixEnv = \"dev\";\n      };\n    }\n  );\n}\n```","ref":"Mix.Tasks.Deps.Nix.html"},{"type":"task","title":"Example with all options - mix deps.nix","doc":"This command creates derivations for everything in `:prod`, and only `ex_doc`\nand `credo` in `:dev`. It will include `:path` dependencies (this option is\nuseful for repos with multiple Mix projects). It outputs the Nix expression\nto `nix/deps.nix`.\n\n```\nmix deps.nix --include-paths --env prod --env dev=ex_doc,credo --output nix/deps.nix\n```","ref":"Mix.Tasks.Deps.Nix.html#module-example-with-all-options"},{"type":"task","title":"Git dependencies - mix deps.nix","doc":"`deps_nix` supports git dependencies.\n\nFor open-source GitHub dependencies, `pkgs.fetchFromGitHub` is used. Hashes\nare prefetched using [Mint](https://hexdocs.pm/mint) and hashed using `nix hash path`.\n\n`builtins.fetchGit` is used for non-GitHub projects, which doesn't require\nany prefetching and relies on the git SHA as a unique identifier. However, it\nsuffers from [several disadvantages](https://discourse.nixos.org/t/fetchgit-vs-fetchgit/23325).","ref":"Mix.Tasks.Deps.Nix.html#module-git-dependencies"},{"type":"exception","title":"DepsNix.InvalidGitHubReference","doc":"","ref":"DepsNix.InvalidGitHubReference.html"},{"type":"extras","title":"deps_nix","doc":"# deps_nix\n\nA Mix task that converts Mix dependencies to Nix derivations. Inspired by\n[mix2nix](https://github.com/ydlr/mix2nix).\n\nWhile mix2nix is a function of a `mix.lock`, this project instead uses Mix's\ninternals to allow you to choose packages from certain environments. It also\nsupports git and path dependencies.","ref":"readme.html"},{"type":"extras","title":"Why? - deps_nix","doc":"You want this if you plan to release your Elixir project using nixpkgs'\n[mixRelease](https://github.com/NixOS/nixpkgs/blob/master/pkgs/development/beam-modules/mix-release.nix),\nor have other uses for wrapping each of your Mix dependencies in derivations.\n\nUsing separate Nix derivations for each dependency:\n\n- Avoids downloading and compiling all of your dependencies for each release,\n  which is what happens when you use a Fixed-Output Derivation (`mixFodDeps` in\n  `mixRelease`).\n- Lets you cache compiled dependencies and reuse them when they don't change,\n  making your release faster. This is especially important when your\n  dependencies take a while to compile.\n- Gives you loads of geek points.","ref":"readme.html#why"},{"type":"extras","title":"Installation - deps_nix","doc":"```elixir\ndef deps do\n  [\n    {:deps_nix, \"~> 1.0\", only: :dev}\n  ]\nend\n```\n\nOptional: add aliases for `deps.get` and `deps.update`. This helps to keep your\nNix dependencies in sync with what's declared in `mix.exs`:\n\n```elixir\ndef project do\n  [\n    ...\n    aliases: [\n      \"deps.get\": [\"deps.get\", \"deps.nix\"],\n      \"deps.update\": [\"deps.update\", \"deps.nix\"]\n    ]\n  ]\nend\n```\n\nDocs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Usage - deps_nix","doc":"```shell\nmix deps.nix\n```\n\nBy default, this will generate a `deps.nix` file in the current directory,\nusing only the `:prod` dependencies for your project.\n\nSee `mix help deps.nix` for more options.","ref":"readme.html#usage"},{"type":"extras","title":"Rustler-precompiled - deps_nix","doc":"deps_nix will work with some dependencies that use\n[rustler-precompiled](https://github.com/philss/rustler_precompiled). For better\ncompatibility with the Nix ecosystem, deps_nix eschews precompiled artifacts\naltogether: it compiles the dependency from scratch to let your project\nleverage Nix caching. This will mean that you'll have to wait for an initial\ncompilation in your CI system.\n\nYou must disable Rustler's compilation for all rustler_precompiled dependencies.\n\ne.g. for explorer, in `config/prod.exs`:\n\n```\nconfig :explorer, Explorer.PolarsBackend.Native, skip_compilation?: true\n```\n\nThe advantage of this approach is that you don't have to update hashes when\ndependencies change. The disadvantage is that you must wait for the compilation\nfor each Nix machine that isn't configured to use a cache, and for each new\nversion.\n\nIf you'd prefer to use the precompiled Rust libraries, this is still possible\nby using a Nix fetcher and providing the library to the dependency inside a\ndirectory that is set as `RUSTLER_PRECOMPILED_GLOBAL_CACHE_PATH` in a custom\noverride.","ref":"readme.html#rustler-precompiled"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}